diff --git a/html/cgi-bin/dns.cgi b/html/cgi-bin/dns.cgi
index 0a097e2c0..13dd9d6a0 100755
--- a/html/cgi-bin/dns.cgi
+++ b/html/cgi-bin/dns.cgi
@@ -272,7 +272,7 @@ my %dns_servers = ();
 # Libloc database handle
 my $libloc_db_handle = &Location::Functions::init();
 
-&Header::openpage($Lang::tr{'dns'}, 1, '');
+&Header::openpage($Lang::tr{'dns title'}, 1, '');
 
 &Header::openbigbox('100%', 'left', '', $errormessage);
 
@@ -419,7 +419,7 @@ END
 # Section to display the configured and used DNS servers.
 #
 sub show_nameservers () {
-	&Header::openbox('100%', 'center', "$Lang::tr{'dns title'}");
+	&Header::openbox('100%', 'center', "$Lang::tr{'dns servers'}");
 
 	# Determine if we are running in recursor mode
 	my $recursor = 0;
diff --git a/langs/de/cgi-bin/de.pl b/langs/de/cgi-bin/de.pl
index 6ad0e02c5..d4dad7652 100644
--- a/langs/de/cgi-bin/de.pl
+++ b/langs/de/cgi-bin/de.pl
@@ -819,7 +819,6 @@
 'dmz pinhole rule removed' => 'Regel für DMZ-Schlupfloch entfernt; Starte DMZ-Schlupfloch neu',
 'dmzpinholes for same net not necessary' => 'DMZ-Schlupflöcher werden im gleichen Netz nicht benötigt. Wählen Sie ein anderes Quell- oder Ziel-Netz.',
 'dnat address' => 'Firewall-Interface',
-'dns' => 'Domain Name System',
 'dns address deleted' => 'Erfolgreich gelöscht! ',
 'dns address deleted txt' => 'DNS Server Adressen wurden erfolgreich gelöscht. Änderungen werden jedoch erst nach einem Neustart oder einer Wiederverbindung übernommen.',
 'dns address done' => 'Die DNS-Server Adressen Einstellungen werden übernommen.',
@@ -848,7 +847,6 @@
 'dns recursor mode' => 'Recursor-Modus',
 'dns saved' => 'Erfolgreich gespeichert!',
 'dns saved txt' => 'Die beiden eingegebenen DNS-Server-Adressen wurde erfolgreich gespeichert.<br/>Um die Änderung wirksam zu machen, müssen Sie neustarten oder wiederverbinden!',
-'dns server' => 'DNS Server',
 'dns servers' => 'DNS-Server',
 'dns title' => 'Domain Name System',
 'dns tls hostname' => 'TLS-Hostname',
diff --git a/langs/en/cgi-bin/en.pl b/langs/en/cgi-bin/en.pl
index d00de3d03..19a5eb02f 100644
--- a/langs/en/cgi-bin/en.pl
+++ b/langs/en/cgi-bin/en.pl
@@ -870,7 +870,6 @@
 'dns recursor mode' => 'Recursor Mode',
 'dns saved' => 'Successfully saved!',
 'dns saved txt' => 'The two entered DNS server addresses have been saved successfully.<br />You have to reboot or reconnect that the changes have effect!',
-'dns server' => 'DNS Server',
 'dns servers' => 'DNS Servers',
 'dns title' => 'Domain Name System',
 'dns tls hostname' => 'TLS Hostname',
diff --git a/langs/fr/cgi-bin/fr.pl b/langs/fr/cgi-bin/fr.pl
index 00328440d..b5232db8c 100644
--- a/langs/fr/cgi-bin/fr.pl
+++ b/langs/fr/cgi-bin/fr.pl
@@ -847,7 +847,6 @@
 'dmz pinhole rule removed' => 'Règle DMZ pinhole supprimée; Redémarrage DMZ pinhole',
 'dmzpinholes for same net not necessary' => 'Les DMZ Pinholes ne sont pas forcément dans le même réseau. Choisir différentes sources ou destinations réseau.',
 'dnat address' => 'Interface pare-feu',
-'dns' => 'Système de noms de domaines',
 'dns address deleted' => 'Suppression effectuée !',
 'dns address deleted txt' => 'Les adresses du serveur DNS ont été supprimées avec succès.<br />Vous devez redémarrer ou reconnecter pour que les modifications prennent effet !',
 'dns address done' => 'Les adresses du serveur DNS vont être sauvegardées.',
@@ -877,7 +876,6 @@
 'dns recursor mode' => 'Exécution en mode récursif.',
 'dns saved' => 'Sauvegarde effectuée !',
 'dns saved txt' => 'La sauvegarde des deux adresses saisies du serveur DNS a été effectée correctement.<br />Vous devez redémarrer ou vous reconnecter pour que les changements prennent effets !',
-'dns server' => 'Serveur DNS',
 'dns servers' => 'Serveurs DNS',
 'dns title' => 'Système de noms de domaine (DNS)',
 'dns tls hostname' => 'Nom d\'hôte TLS',
diff --git a/langs/it/cgi-bin/it.pl b/langs/it/cgi-bin/it.pl
index d0e9dc4c9..ada8887ac 100644
--- a/langs/it/cgi-bin/it.pl
+++ b/langs/it/cgi-bin/it.pl
@@ -764,7 +764,6 @@
 'dns proxy server' => 'DNS Proxy Server',
 'dns saved' => 'Successfully saved!',
 'dns saved txt' => 'The two entered DNS server addresses have been saved successfully.<br />You have to reboot or reconnect that the changes have effect!',
-'dns server' => 'DNS Server',
 'dns servers' => 'DNS Servers',
 'dns title' => 'Domain Name System',
 'dnsforward' => 'Inoltro DNS',
diff --git a/langs/nl/cgi-bin/nl.pl b/langs/nl/cgi-bin/nl.pl
index f67eb0383..bbd5a3f3d 100644
--- a/langs/nl/cgi-bin/nl.pl
+++ b/langs/nl/cgi-bin/nl.pl
@@ -754,7 +754,7 @@
 'dns proxy server' => 'DNS Proxy Server',
 'dns saved' => 'Succesvol opgeslagen!',
 'dns saved txt' => 'De twee ingevoerde DNS serveradressen zijn succesvol opgeslagen.<br />U moet herstarten of opnieuw verbinden om de wijzigingen actief te laten worden!',
-'dns server' => 'DNS Server',
+'dns servers' => 'DNS Server',
 'dns title' => 'Domein Naam Systeem',
 'dnsforward' => 'DNS Forwarding',
 'dnsforward add a new entry' => 'Voeg een nieuwe regel toe',
diff --git a/langs/pl/cgi-bin/pl.pl b/langs/pl/cgi-bin/pl.pl
index 3f4fc0143..e85173021 100644
--- a/langs/pl/cgi-bin/pl.pl
+++ b/langs/pl/cgi-bin/pl.pl
@@ -686,7 +686,7 @@
 'dns proxy server' => 'Serwer Proxy DNS',
 'dns saved' => 'Zapisano poprawnie!',
 'dns saved txt' => 'Podane adresy serwerów DNS zostały poprawnie zapisane. <br />Należy wykonać restart lub wykonać ponowne łączenie, aby zmiany zostały zastosowane!',
-'dns server' => 'Serwer DNS',
+'dns servers' => 'Serwer DNS',
 'dns title' => 'Domain Name System',
 'do not log this port list' => 'Odrzucaj tą listę portów zanim zostaną zapisane do logu (zmniejsza rozmiar logów)',
 'dod' => 'Łącz na żądanie',
diff --git a/langs/ru/cgi-bin/ru.pl b/langs/ru/cgi-bin/ru.pl
index 2c91a3fee..371394474 100644
--- a/langs/ru/cgi-bin/ru.pl
+++ b/langs/ru/cgi-bin/ru.pl
@@ -682,7 +682,7 @@
 'dns proxy server' => 'DNS Proxy Сервер',
 'dns saved' => 'Successfully saved!',
 'dns saved txt' => 'The two entered DNS server addresses have been saved successfully.<br />You have to reboot or reconnect that the changes have effect!',
-'dns server' => 'DNS Сервер',
+'dns servers' => 'DNS Сервер',
 'dns title' => 'Domain Name System',
 'do not log this port list' => 'Drop this port list just before they are logged (reduces log size)',
 'dod' => 'Dial on Demand',
diff --git a/langs/tr/cgi-bin/tr.pl b/langs/tr/cgi-bin/tr.pl
index b958d63fe..da868a312 100644
--- a/langs/tr/cgi-bin/tr.pl
+++ b/langs/tr/cgi-bin/tr.pl
@@ -836,7 +836,6 @@
 'dns proxy server' => 'DNS Vekil Sunucusu',
 'dns saved' => 'Başarıyla kaydedildi!',
 'dns saved txt' => 'Girilen iki DNS sunucu adresi başarılı bir şekilde kaydedildi.<br />Değişikliklerin aktifleştirielebilmesi için yeniden başlatın!',
-'dns server' => 'DNS Sunucusu',
 'dns servers' => 'DNS sunucuları',
 'dns title' => 'Etki Alanı Ad Sistemi',
 'dnsforward' => 'DNS Yönlendirmesi',